
   MEMBER

   MAP
   .

   Include('jhSliderCL.inc'),ONCE


mem:Icon:Slider:On            EQUATE('~Slider-On.png')
mem:Icon:Slider:Off           EQUATE('~Slider-Off.png')

jhEntryQ_Type                 Queue,Type
dwFEQ                            LONG
dwButtonFEQ                      LONG

theField                         ANY            ! Use this to reference the actual variable, typically a BYTE but can be a LONG
                              .  

   



!=======================================================================================================================
!--      
jhSliderCL_type.Construct  PROCEDURE
   Code
      SELF.EntryQ &= NEW(jhEntryQ_Type)
      
      
!=======================================================================================================================
!--      
jhSliderCL_type.Destruct   PROCEDURE
i                             LONG
   Code         
      Loop i = RECORDS(SELF.EntryQ) TO 1 BY -1
         GET(SELF.EntryQ,i)
         if ~ERRORCODE()
            SELF.EntryQ.theField &= NULL
            DELETE(SELF.EntryQ)
         .
      .

      DISPOSE(SELF.EntryQ)

!=======================================================================================================================
!--      
jhSliderCL_type.GetFEQ     Procedure(LONG inFEQ)!,LONG
   Code
      SELF.EntryQ.dwFEQ = inFEQ
      GET(SELF.EntryQ,SELF.EntryQ.dwFEQ)
      if ~ERRORCODE()
         RETURN(SELF.EntryQ.dwButtonFEQ)
      .
      
      Return(0)

      
!=======================================================================================================================
!--      
jhSliderCL_type.SetValue PROCEDURE(LONG inFEQ,BYTE inValue,BYTE inEnabled=1)
   Code  
      SELF.EntryQ.dwFEQ = inFEQ
      GET(SELF.EntryQ,SELF.EntryQ.dwFEQ)
      if ~ERRORCODE()
         if inValue = TRUE
            SELF.EntryQ.dwButtonFEQ{PROP:Icon} = mem:Icon:Slider:On
            SELF.EntryQ.theField = TRUE
         ELSE
            SELF.EntryQ.dwButtonFEQ{PROP:Icon} = mem:Icon:Slider:Off
            SELF.EntryQ.theField = TRUE
         .
         
         PUT(SELF.EntryQ)
      .


!=======================================================================================================================
!--      
jhSliderCL_type.GetValue PROCEDURE(LONG inFEQ)
   Code  
      SELF.EntryQ.dwFEQ = inFEQ
      GET(SELF.EntryQ,SELF.EntryQ.dwFEQ)
      if ~ERRORCODE()
         Return(SELF.EntryQ.theField)
      .
      
      Return(0)

      
!=======================================================================================================================
!-- Create a new "Slider" ..
!--   1. Hide the underlying check box control
!--   2. Create a button over the original check box
!--      
jhSliderCL_type.AddEntry   PROCEDURE(LONG inFEQ,*? ioVariable,LONG inParentFEQ)
   Code          
      !-- Hide inFEQ ..
      !-- 
      HIDE(inFEQ)
        
      CLEAR(SELF.EntryQ)
      SELF.EntryQ.dwFEQ = inFEQ            
      SELF.EntryQ.theField &= ioVariable
      
      !-- Create the Button ..
      !--
      SELF.EntryQ.dwButtonFEQ = CREATE(0,CREATE:button)
      SELF.EntryQ.dwButtonFEQ{PROP:Xpos} = inFEQ{PROP:Xpos} - 2
      SELF.EntryQ.dwButtonFEQ{PROP:Ypos} = inFEQ{PROP:Ypos} - 2
      SELF.EntryQ.dwButtonFEQ{PROP:Width} = inFEQ{PROP:Width} + 4
      SELF.EntryQ.dwButtonFEQ{PROP:Height} = inFEQ{PROP:Height} + 4
      SELF.EntryQ.dwButtonFEQ{PROP:Flat} = TRUE
      SELF.EntryQ.dwButtonFEQ{PROP:Skip} = TRUE                    ! This prevents the selector staying around the control once toggled
      
      if SELF.EntryQ.theField = TRUE
         SELF.EntryQ.dwButtonFEQ{PROP:Icon} = mem:Icon:Slider:On
      ELSE
         SELF.EntryQ.dwButtonFEQ{PROP:Icon} = mem:Icon:Slider:Off
      .
      
      UNHIDE(SELF.EntryQ.dwButtonFEQ)         
         
      Add(SELF.EntryQ)
      
      
              
!=======================================================================================================================
!-- Enable/Disable the control, ie: change the slider graphic and change the Region{PROP:IMM}
!--      
jhSliderCL_Type.Enable     PROCEDURE(LONG inFEQ)                       
   Code
      SELF.EntryQ.dwFEQ = inFEQ
      GET(SELF.EntryQ,SELF.EntryQ.dwFEQ)
      if ~ERRORCODE()                  
         Enable(SELF.EntryQ.dwButtonFEQ)
         PUT(SELF.EntryQ)
      .
      

!=======================================================================================================================
!-- Disable the control, ie: change the slider graphic and change the Region{PROP:IMM}
!--      
jhSliderCL_Type.Disable PROCEDURE(LONG inFEQ)                       
   Code          
      SELF.EntryQ.dwFEQ = inFEQ
      GET(SELF.EntryQ,SELF.EntryQ.dwFEQ)
      if ~ERRORCODE()
         DISABLE(SELF.EntryQ.dwButtonFEQ)
         PUT(SELF.EntryQ)
      .

      
!=======================================================================================================================
!--      
jhSliderCL_Type.TakeEvent  PROCEDURE

i                             LONG

   Code  
      CASE Event()  
      of EVENT:Accepted  
         !-- Look for the dwButtonFEQ 
         LOOP i = 1 to RECORDS(SELF.EntryQ)
            GET(SELF.EntryQ,i)
            if ~ERRORCODE()
               if SELF.EntryQ.dwButtonFEQ = FIELD()
                  if SELF.EntryQ.theField = TRUE
                     SELF.EntryQ.theField = FALSE
                     SELF.EntryQ.dwButtonFEQ{PROP:Icon} = mem:Icon:Slider:Off
                  ELSE
                     SELF.EntryQ.theField = TRUE
                     SELF.EntryQ.dwButtonFEQ{PROP:Icon} = mem:Icon:Slider:On
                  .   
                  
                  PUT(SELF.EntryQ)

                  !-- POST an Event:Accepted to the underlying FEQ so that it can be processed as normal
                  !--
                  POST(EVENT:Accepted,SELF.EntryQ.dwFEQ)
                  
                  BREAK
               .
            .    
         .
      .
      
      
         